/* 
* Sir Drink a lots Goal Announcer
* 
* Announces Bomb spawned, lost, got, planting, defusing
* Announces Hostage touched, rescued, killed
* Announces Became_VIP, VIP_Assassinated
* 
*
* NEW:
* - Die #defines dienen dazu, um festzulege, wer die Nachricht zu lesen bekommen darf.
*/ 

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE 131072

new STRING_VERSION[MAX_DATA_LENGTH] = "01.07.03";

#define MAX_ENTRIES 11

new LogEntries[MAX_ENTRIES][MAX_TEXT_LENGTH]=	{{"Spawned_With_The_Bomb"},{"Begin_Bomb_Defuse_With_Kit"},
						{"Begin_Bomb_Defuse_Without_Kit"},{"Got_The_Bomb"},
						{"Dropped_The_Bomb"},{"Planted_The_Bomb"},{"Touched_A_Hostage"},{"Killed_A_Hostage"},
						{"Rescued_A_Hostage"},{"Became_VIP"},{"VIP_Assassinated"}};

/* Allgemeine Festlegung von T, CT oder an alle Spieler. */						
#define ALL	0
#define CT	2
#define T	1

/* Definition, wer welche Meldungen zu sehen bekommt. */
#define SPAWN_BOMB	T
#define DEF_B_W_DK	ALL
#define DEF_B_WO_DK	ALL
#define GOT_BOMB	T
#define DROP_BOMB	T
#define PLANT_BOMB	ALL
#define TOUCH_HOST	CT
#define KILL_HOST	ALL
#define RESC_HOST	ALL
#define BECAME_VIP	CT
#define ASSASS_VIP	ALL
						
new ReactionMsg[MAX_ENTRIES][MAX_TEXT_LENGTH]=	{{"spawned with the bomb!"},{"begins defusing the bomb^nwith defuse kit!"},
						{"begins defusing the bomb^nwithout defuse kit!"},
						{"got the bomb!"},{"dropped the bomb!"},{"planted the bomb!"},{"touched a hostage!"},
						{"killed a hostage!"},{"rescued a hostage"},{"became VIP!"},{"is assassinated!"}};
						
new Announcement[MAX_ENTRIES][2]=		{{SPAWN_BOMB},{DEF_B_W_DK},{DEF_B_WO_DK},{GOT_BOMB},{DROP_BOMB},{PLANT_BOMB},{TOUCH_HOST},
						{KILL_HOST},{RESC_HOST},{BECAME_VIP},{ASSASS_VIP}};
										

public logd_goalannounce(HLCommand,HLData,HLUserName,UserIndex){ 
	new Data[MAX_DATA_LENGTH]; 
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH]; 
	new Target[MAX_NAME_LENGTH]; 
	new sID[MAX_DATA_LENGTH];
	new i;
	new j;
	new maxplayers=maxplayercount();
	new iTeam;
	new iID; 

	convert_string(HLData, Data, MAX_DATA_LENGTH); 
	strbreak(Data, sID, Data, MAX_DATA_LENGTH); 
	
	iID= strtonum( sID );
	
	if(playerinfo(iID,User,MAX_NAME_LENGTH)){
		for(i=0;i<=MAX_ENTRIES;i++){
			if(strcmp(Data, LogEntries[i]) == 0) { 
				snprintf(Text, MAX_TEXT_LENGTH, "%s^n%s", User, ReactionMsg[i]); 
				if(Announcement[i][0]==ALL){
					centersay(Text, 12, random(255),random(255),random(255));
				}else{
					for(j=1;j<=maxplayers;j++){
						if(playerinfo(j,Target,MAX_NAME_LENGTH,_,_,iTeam)){
							if(iTeam==Announcement[i][0]){
								messageex(Target,Text,print_pretty);
							}
						}
					}
				}
				break;
			}
		}
	}	
	return PLUGIN_CONTINUE; 
} 

public plugin_init() { 
	plugin_registerinfo("Goal Announcing","Schreibt in Centersay wer die Bombe legt.",STRING_VERSION); 
	plugin_registercmd("logd_goalannounce", "logd_goalannounce", ACCESS_CONSOLE, ""); 
	exec( "logd_reg 60 admin_command logd_goalannounce" ); 
	return PLUGIN_CONTINUE; 
}